import java.text.*;
import com.imsl.stat.*;
import com.imsl.IMSLException.*;
import com.imsl.math.PrintMatrix;
import com.imsl.math.PrintMatrixFormat;

public class StepwiseRegressionEx1 {

   public static void main(String[] args)  throws Exception {
      double x[][] = {
         {7., 26., 6., 60.},
         {1., 29., 15., 52.},
         {11., 56., 8., 20.},
         {11., 31., 8., 47.},
         {7., 52., 6., 33.},
         {11., 55., 9., 22.},
         {3., 71., 17., 6.},
         {1., 31., 22., 44.},
         {2., 54., 18., 22.},
         {21., 47., 4., 26},
         {1., 40., 23., 34.},
         {11., 66., 9., 12.},
         {10.0, 68., 8., 12.}};

      double y[] = {
         78.5, 74.3, 104.3, 87.6, 95.9, 109.2, 102.7, 
         72.5, 93.1, 115.9, 83.8, 113.3, 109.4};

      StepwiseRegression sr = new StepwiseRegression(x,y);
      sr.compute();
      
      PrintMatrix pm = new PrintMatrix();
      pm.setTitle("*** ANOVA *** "); pm.print(sr.getANOVA().getArray());
      
      StepwiseRegression.CoefficientTTests coefT = sr.getCoefficientTTests();
      double coef[][] = new double[4][4];
      for (int i=0; i<4; i++) {
          coef[i][0] = coefT.getCoefficient(i);
          coef[i][1] = coefT.getStandardError(i);
          coef[i][2] = coefT.getTStatistic(i);
          coef[i][3] = coefT.getPValue(i);
      }
      pm.setTitle("*** Coef *** "); pm.print(coef);
      pm.setTitle("*** Swept *** "); pm.print(sr.getSwept());
      pm.setTitle("*** History *** "); pm.print(sr.getHistory());
      pm.setTitle("*** VIF *** "); pm.print(sr.getCoefficientVIF());
      pm.setTitle("*** CovS *** "); pm.print(sr.getCovariancesSwept());
   }
}
